/* 
 *  Arnold emulator (c) Copyright, Kevin Thacker 1995-2001
 *  
 *  This file is part of the Arnold emulator source code distribution.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
/* THIS IS NOT COMPLETE */
/* Snapshot V3 format as used by No$CPC v1.8 */

#include "cpcglob.h"
#include "cpcdefs.h"
#include "snapv3.h"
#include "riff.h"
#include <stdlib.h>
#include "host.h"
#include "cpc.h"
#include "z80/z80.h"

void	SnapshotV3_HandleChunk(RIFF_CHUNK *pCurrentChunk)
{
	unsigned long ChunkName = Riff_GetChunkName(pCurrentChunk);

	switch (ChunkName)
	{
		case RIFF_FOURCC_CODE('C','P','C','+'):
		{
			unsigned char *pChunkData = Riff_GetChunkDataPtr(pCurrentChunk);
			unsigned char *pASICRam = ASIC_GetRamPtr();
			unsigned long ASICRamOffset;
			int i;

			/* sprite data */
			ASICRamOffset = 0x04000;

			for (i=0; i<((16*16*16)>>1); i++)
			{
				unsigned char PackedPixels;

				PackedPixels = pChunkData[0];

				ASIC_WriteRam(ASICRamOffset, (PackedPixels>>4) & 0x0f);
				ASICRamOffset++;
				ASIC_WriteRam(ASICRamOffset, PackedPixels & 0x0f);
				ASICRamOffset++;
				pChunkData++;
			}

			/* sprite attributes */
			ASICRamOffset = 0x06000;

			for (i=0; i<16; i++)
			{
				/* x */
				ASIC_WriteRam(ASICRamOffset, pChunkData[0]);
				pChunkData++;
				ASICRamOffset++;

				ASIC_WriteRam(ASICRamOffset, pChunkData[0]);
				pChunkData++;
				ASICRamOffset++;

				/* y */
				ASIC_WriteRam(ASICRamOffset, pChunkData[0]);
				pChunkData++;
				ASICRamOffset++;

				ASIC_WriteRam(ASICRamOffset, pChunkData[0]);
				pChunkData++;
				ASICRamOffset++;

				/* mag */
				ASIC_WriteRam(ASICRamOffset, pChunkData[0]);
				pChunkData++;
				ASICRamOffset++;

				/* unused */
				pChunkData+=3;
				ASICRamOffset+=3;
			}

			/* palettes */
			ASICRamOffset = 0x06400;

			for (i=0; i<32; i++)
			{
				ASIC_WriteRam(ASICRamOffset, pChunkData[0]);
				pChunkData++;
				ASICRamOffset++;

				ASIC_WriteRam(ASICRamOffset, pChunkData[0]);
				pChunkData++;
				ASICRamOffset++;
			}

			/* misc */
			ASICRamOffset = 0x06400;

			for (i=0; i<32; i++)
			{
				ASIC_WriteRam(ASICRamOffset, pChunkData[0]);
				pChunkData++;
				ASICRamOffset++;

				ASIC_WriteRam(ASICRamOffset, pChunkData[0]);
				pChunkData++;
				ASICRamOffset++;
			}

			ASIC_WriteRam(0x06800, pChunkData[0]);
			pChunkData++;

			ASIC_WriteRam(0x06801, pChunkData[0]);
			pChunkData++;

			ASIC_WriteRam(0x06802, pChunkData[0]);
			pChunkData++;

			ASIC_WriteRam(0x06803, pChunkData[0]);
			pChunkData++;

			ASIC_WriteRam(0x06804, pChunkData[0]);
			pChunkData++;

			ASIC_WriteRam(0x06805, pChunkData[0]);
			pChunkData++;

			/* skip unused */
			pChunkData+=2;

			/* analogue inputs */
			for (i=0; i<8; i++)
			{
				ASIC_SetAnalogueInput(i,pChunkData[0]);
				pChunkData++;
			}
			
			/* dma */
			ASICRamOffset = 0x06c00;

			for (i=0; i<3; i++)
			{
				/* address */
				ASIC_WriteRam(ASICRamOffset, pChunkData[0]);
				pChunkData++;
				ASICRamOffset++;

				ASIC_WriteRam(ASICRamOffset, pChunkData[0]);
				pChunkData++;
				ASICRamOffset++;

				/* prescale */
				ASIC_WriteRam(ASICRamOffset, pChunkData[0]);
				pChunkData++;
				ASICRamOffset++;

				/* unused */
				pChunkData++;
				ASICRamOffset++;
			}

			/* DCSR */
			ASIC_WriteRam(ASICRamOffset, pChunkData[0]);
			pChunkData++;
			ASICRamOffset++;


		}
		break;


		/* this will not necessarily be portable across all systems! */
		case RIFF_FOURCC_CODE('C','A','R','T'):
		{
			Cartridge_Load((char *)Riff_GetChunkDataPtr(pCurrentChunk));
		}
		break;

		/* this will not necessarily be portable across all systems! */
		case RIFF_FOURCC_CODE('E','X','0','0'):
		case RIFF_FOURCC_CODE('E','X','0','1'):
		case RIFF_FOURCC_CODE('E','X','0','2'):
		case RIFF_FOURCC_CODE('E','X','0','3'):
		case RIFF_FOURCC_CODE('E','X','0','4'):
		case RIFF_FOURCC_CODE('E','X','0','5'):
		case RIFF_FOURCC_CODE('E','X','0','6'):
		case RIFF_FOURCC_CODE('E','X','0','7'):
		case RIFF_FOURCC_CODE('E','X','0','8'):
		case RIFF_FOURCC_CODE('E','X','0','9'):
		case RIFF_FOURCC_CODE('E','X','1','0'):
		case RIFF_FOURCC_CODE('E','X','1','1'):
		case RIFF_FOURCC_CODE('E','X','1','2'):
		case RIFF_FOURCC_CODE('E','X','1','3'):
		case RIFF_FOURCC_CODE('E','X','1','4'):
		case RIFF_FOURCC_CODE('E','X','1','5'):
		{
			int ExpansionRomIndex = 0;

			ExpansionRom_Insert((char *)Riff_GetChunkDataPtr(pCurrentChunk),ExpansionRomIndex);
			ExpansionRom_SetActiveState(ExpansionRomIndex,TRUE);
		}
		break;


	}
}

