/* 
 *  Arnold emulator (c) Copyright, Kevin Thacker 1995-2001
 *  
 *  This file is part of the Arnold emulator source code distribution.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
#include "../cpc/host.h"
#include "display.h"
#include <sys/time.h>
#include <unistd.h>

static GRAPHICS_BUFFER_INFO BufferInfo;
static GRAPHICS_BUFFER_COLOUR_FORMAT BufferColourFormat;
static SOUND_PLAYBACK_FORMAT SoundFormat;

BOOL	Host_SetDisplay(int Type, int Width, int Height, int Depth)
{
	int DispType;

	if (Type == DISPLAY_TYPE_WINDOWED)
	{
		XWindows_SetDisplayWindowed(Width, Height, Depth);
	}
	else
	{
		XWindows_SetDisplayWindowed(Width, Height, Depth);
	}

	return TRUE;
}


BOOL	Host_LockGraphicsBuffer(void);	
GRAPHICS_BUFFER_INFO	*Host_GetGraphicsBufferInfo(void);
void	Host_UnlockGraphicsBuffer(void);
void	Host_SetPaletteEntry(int, unsigned char, unsigned char, unsigned char);
BOOL	Host_SetDisplay(int Type, int Width, int Height, int Depth);


GRAPHICS_BUFFER_COLOUR_FORMAT *Host_GetGraphicsBufferColourFormat()
{
	XWindows_GetGraphicsBufferColourFormat(&BufferColourFormat);

	return &BufferColourFormat;
}

GRAPHICS_BUFFER_INFO *Host_GetGraphicsBufferInfo()
{
	XWindows_GetGraphicsBufferInfo(&BufferInfo);

	return &BufferInfo;
}

BOOL	Host_LockGraphicsBuffer(void)
{
//	printf("buffer lock\r\n");

	return TRUE;
}


void	Host_UnlockGraphicsBuffer(void)
{
}

void	Host_SwapGraphicsBuffers(void)
{
	XWindows_SwapGraphicsBuffers();
}

void	Host_SetPaletteEntry(int Index, unsigned char R, unsigned char G, unsigned char B)
{
}

void	Host_WriteDataToSoundBuffer(unsigned char *pData, unsigned long Length)
{
}		

BOOL	Host_AudioPlaybackPossible(void)
{
	return FALSE;
}

SOUND_PLAYBACK_FORMAT *Host_GetSoundPlaybackFormat(void)
{
	return &SoundFormat;
}

BOOL XWindows_ProcessSystemEvents();


BOOL	Host_ProcessSystemEvents(void)
{	
	return XWindows_ProcessSystemEvents();
}

void	Host_DoDriveLEDIndicator(int Drive, BOOL State)
{
}


void	Host_SetDirectory(char *Directory)
{
	chdir(Directory);
}

void	Host_Throttle(void)
{
}

BOOL	Host_LockAudioBuffer(unsigned char **pBlock1, unsigned long
*pBlock1Size, unsigned char **pBlock2, unsigned long *pBlock2Size, int
Flags)
{	
	return FALSE;

}

void	Host_UnLockAudioBuffer(void)
{
}

unsigned long	Host_GetCurrentTimeInMilliseconds(void)
{
	struct timeval tv;
	
	gettimeofday(&tv,NULL);
	return 1000*tv.tv_sec+tv.tv_usec/1000;
}
